# TP 09 (fichier à compléter) : Recherche dans un texte
# BCPST1B 2024-2025
# Lycée Hoche, Versailles
# L.-C. LEFÈVRE

#%% exécuter une fois pour toute au début du TP

with open("livre.txt", "r", encoding="utf-8") as f:
    livre = f.read()[615:-18798]

print(livre[:664])
print("\n[...]\n")
print(livre[-3:])

#%% exercice 1.1

def cherche_caractere(s, x):
    ...

# test
s = "abracadabra"
x = "a"
print("s =", s)
print("x =", x)
cherche_caractere(s, x)
x = "z"
print("x =", x)
cherche_caractere(s, x)
x = "c"
print("x =", x)
cherche_caractere(s, x)

#%% exercice 1.2

def compte_caractere(s, x):
    ...

# test
s = "TTAATGCAATAAC"
print("s =", s)
x = "A"
print("x =", x)
print(compte_caractere(s, x))
x = "G"
print("x =", x)
print(compte_caractere(s, x))

print("(livre)")
x = "e"
print("x =", x)
print(compte_caractere(livre, x))
x = "x"
print("x =", x)
print(compte_caractere(livre, x))

#%% exercice 3

def le_mot_est_ici(s, m, i):
    n = len(s)
    p = len(m)
    # condition dégagée à l'exercice 2
    if ... :
        return False
    ...

# test
s = "TTAATGCAATAAC"
m = "AAT"
print("s =", s)
print("m =", m)
for i in range(len(s)):
    print(i, le_mot_est_ici(s, m, i))

#%% exercice 4.1

def cherche_mot(s, m):
    ...

# test
s = "abracadabra"
m = "abra"
print("s =", s)
print("m =", m)
cherche_mot(s, m)
m = "cad"
print("m =", m)
cherche_mot(s, m)

#%% exercice 4.2

def compte_mot(s, m):
    ...

# test
s = "abracadabra"
m = "abra"
print("s =", s)
print("m =", m)
print(compte_mot(s, m))
m = "cad"
print("m =", m)
print(compte_mot(s, m))

print("(livre)")
m = "amour"
print("m =", m)
print(compte_mot(livre, m))
# à vous ! testez en mode interactif
# compte_mot(livre, "...")

#%% bonus

def cherche_mot_plus(s, m):
    ...

# test : à vous
# cherche_mot_plus(livre, "...")

#%% exercice 5

def distance(s, t):
    n = len(s)
    assert n == len(t), "Les deux mots doivent être de même longueur."
    ...

# test
s = "python"
t = "patron"
print("s =", s, "t =", t)
print(distance(s, t))
t = "pieton"
print("s =", s, "t =", t)
print(distance(s, t))
t = "bureau"
print("s =", s, "t =", t)
print(distance(s, t))

#%% exercice 6.1

def lmeappi(s, m, i, seuil):
    n = len(s)
    p = len(m)
    ...

#%% exercice 6.2

def cherche_mot_erreurs(s, m, seuil):
    ...

# test : à vous de régler les paramètres, on cherche dans le livre
cherche_mot_erreurs(livre, "amour", 1)
# attention : sur un mot de 5 lettres, un seuil de 3 donne beaucoup trop de mots...

#%% exercice 7.1

def est_bord(m, k):
    ...

# test
m = "AGTCGAGT"
print("m =", m)
for k in range(len(m)):
    print(k, est_bord(m, k))

#%% exercice 7.2

def longueur_bord(m):
    ...

# test
m = "AGTCGAGT"
print("m =", m)
print(longueur_bord(m))
m = "TTTGCCTTT"
print("m =", m)
print(longueur_bord(m))
m = "AGTCGAGTC"
print("m =", m)
print(longueur_bord(m))
m = "AGTCGAGTC"
print("m =", m)
print(longueur_bord(m))

#%% exercice 7.3

def longueurs_bords_prefixes(m):
    ...

m = "AATGAATC"
print("m =", m)
print(longueurs_bords_prefixes(m))

#%% exercice 8

def cherche_KMP(s, m):
    n = len(s)
    p = len(m)
    B = longueurs_bords_prefixes(...)
    i = 0
    j = 0
    while i <= ... :
        while j < ... and m[...] == s[i+j]:
            j = j + 1
        if j == ... :
            print("Trouvé à", i)
            i = ...
            j = ...
        elif j == ... :
            print("Ne démarre pas à", i, "saut de", 1)
            i = i + 1
            j = ...
        else:
            print("Ne démarre pas à", i, "saut de", j - B[j-1])
            i = ...
            j = B[j-1]

# test
s = "AGTAGCAGCT"
m = "AGCT"
print("s =", s)
print("m =", m)
cherche_KMP(s, m)

s = "ACACATAG"
m = "ACAT"
print("s =", s)
print("m =", m)
cherche_KMP(s, m)

s = "ATCGATCGATCGATG"
m = "ATCGATG"
print("s =", s)
print("m =", m)
cherche_KMP(s, m)
